Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 1 | # =========================================================================== |
| 2 | # Kernel configuration targets |
| 3 | # These targets are used from top-level makefile |
| 4 | |
Michal Marek | 1cba0c3 | 2015-04-08 11:11:57 +0200 | [diff] [blame] | 5 | PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \ |
Steven Rostedt | 281c9da | 2009-04-29 22:52:23 -0400 | [diff] [blame] | 6 | localmodconfig localyesconfig |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 7 | |
Al Viro | 61bee20 | 2008-08-25 04:51:27 -0400 | [diff] [blame] | 8 | ifdef KBUILD_KCONFIG |
| 9 | Kconfig := $(KBUILD_KCONFIG) |
| 10 | else |
Arnaud Lacombe | 838a2e5 | 2010-09-04 17:10:20 -0400 | [diff] [blame] | 11 | Kconfig := Kconfig |
Al Viro | 61bee20 | 2008-08-25 04:51:27 -0400 | [diff] [blame] | 12 | endif |
Sam Ravnborg | e703f75 | 2007-10-25 20:42:18 +0200 | [diff] [blame] | 13 | |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 14 | ifeq ($(quiet),silent_) |
| 15 | silent := -s |
| 16 | endif |
| 17 | |
Yann E. MORIN | c2838e6 | 2012-11-22 01:06:04 +0100 | [diff] [blame] | 18 | # We need this, in case the user has it in its environment |
| 19 | unexport CONFIG_ |
| 20 | |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 21 | xconfig: $(obj)/qconf |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 22 | $< $(silent) $(Kconfig) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 23 | |
| 24 | gconfig: $(obj)/gconf |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 25 | $< $(silent) $(Kconfig) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 26 | |
| 27 | menuconfig: $(obj)/mconf |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 28 | $< $(silent) $(Kconfig) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 29 | |
| 30 | config: $(obj)/conf |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 31 | $< $(silent) --oldaskconfig $(Kconfig) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 32 | |
nir.tzachar@gmail.com | 692d97c | 2009-11-25 12:28:43 +0200 | [diff] [blame] | 33 | nconfig: $(obj)/nconf |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 34 | $< $(silent) $(Kconfig) |
nir.tzachar@gmail.com | 692d97c | 2009-11-25 12:28:43 +0200 | [diff] [blame] | 35 | |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 36 | silentoldconfig: $(obj)/conf |
Masahiro Yamada | 9815594 | 2014-05-29 14:33:03 +0900 | [diff] [blame] | 37 | $(Q)mkdir -p include/config include/generated |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 38 | $< $(silent) --$@ $(Kconfig) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 39 | |
Arnaud Lacombe | 50bce3e | 2011-07-01 18:13:03 -0400 | [diff] [blame] | 40 | localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf |
Masahiro Yamada | 9815594 | 2014-05-29 14:33:03 +0900 | [diff] [blame] | 41 | $(Q)mkdir -p include/config include/generated |
Arnaud Lacombe | 22d550a | 2011-07-20 00:40:09 -0400 | [diff] [blame] | 42 | $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config |
Michal Marek | 7a996d3 | 2010-08-04 14:05:07 +0200 | [diff] [blame] | 43 | $(Q)if [ -f .config ]; then \ |
Sam Ravnborg | 4062f1a | 2010-07-31 23:35:26 +0200 | [diff] [blame] | 44 | cmp -s .tmp.config .config || \ |
| 45 | (mv -f .config .config.old.1; \ |
| 46 | mv -f .tmp.config .config; \ |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 47 | $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \ |
Sam Ravnborg | 4062f1a | 2010-07-31 23:35:26 +0200 | [diff] [blame] | 48 | mv -f .config.old.1 .config.old) \ |
| 49 | else \ |
| 50 | mv -f .tmp.config .config; \ |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 51 | $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \ |
Steven Rostedt | a7c0260 | 2009-05-07 11:09:55 -0400 | [diff] [blame] | 52 | fi |
Steven Rostedt | 03fa25d | 2009-04-29 22:52:22 -0400 | [diff] [blame] | 53 | $(Q)rm -f .tmp.config |
| 54 | |
EGRY Gabor | 1020026 | 2008-01-11 23:40:00 +0100 | [diff] [blame] | 55 | # Create new linux.pot file |
Sam Ravnborg | b70e325c | 2007-06-10 20:38:27 +0200 | [diff] [blame] | 56 | # Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files |
EGRY Gabor | 46d2631 | 2008-01-11 23:46:11 +0100 | [diff] [blame] | 57 | update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 58 | $(Q)$(kecho) " GEN config.pot" |
Peter Foley | a24a1b8 | 2011-04-26 18:13:05 -0400 | [diff] [blame] | 59 | $(Q)xgettext --default-domain=linux \ |
| 60 | --add-comments --keyword=_ --keyword=N_ \ |
| 61 | --from-code=UTF-8 \ |
| 62 | --files-from=$(srctree)/scripts/kconfig/POTFILES.in \ |
| 63 | --directory=$(srctree) --directory=$(objtree) \ |
Sam Ravnborg | b70e325c | 2007-06-10 20:38:27 +0200 | [diff] [blame] | 64 | --output $(obj)/config.pot |
| 65 | $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot |
Paul Bolle | fa0ad657 | 2011-11-05 12:21:30 +0100 | [diff] [blame] | 66 | $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \ |
| 67 | $(srctree)/arch/*/um/Kconfig`; \ |
EGRY Gabor | 1020026 | 2008-01-11 23:40:00 +0100 | [diff] [blame] | 68 | do \ |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 69 | $(kecho) " GEN $$i"; \ |
Sam Ravnborg | 4217516 | 2008-04-25 21:15:41 +0200 | [diff] [blame] | 70 | $(obj)/kxgettext $$i \ |
EGRY Gabor | 1020026 | 2008-01-11 23:40:00 +0100 | [diff] [blame] | 71 | >> $(obj)/config.pot; \ |
| 72 | done ) |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 73 | $(Q)$(kecho) " GEN linux.pot" |
EGRY Gabor | 1020026 | 2008-01-11 23:40:00 +0100 | [diff] [blame] | 74 | $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \ |
Sam Ravnborg | b70e325c | 2007-06-10 20:38:27 +0200 | [diff] [blame] | 75 | --output $(obj)/linux.pot |
Sam Ravnborg | b70e325c | 2007-06-10 20:38:27 +0200 | [diff] [blame] | 76 | $(Q)rm -f $(obj)/config.pot |
Arnaldo Carvalho de Melo | 3b9fa09 | 2005-05-05 15:09:46 -0700 | [diff] [blame] | 77 | |
Michal Marek | 1cba0c3 | 2015-04-08 11:11:57 +0200 | [diff] [blame] | 78 | # These targets map 1:1 to the commandline options of 'conf' |
| 79 | simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \ |
| 80 | alldefconfig randconfig listnewconfig olddefconfig |
| 81 | PHONY += $(simple-targets) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 82 | |
Michal Marek | 1cba0c3 | 2015-04-08 11:11:57 +0200 | [diff] [blame] | 83 | $(simple-targets): $(obj)/conf |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 84 | $< $(silent) --$@ $(Kconfig) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 85 | |
Michal Marek | 1cba0c3 | 2015-04-08 11:11:57 +0200 | [diff] [blame] | 86 | PHONY += oldnoconfig savedefconfig defconfig |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 87 | |
Adam Lee | fb16d89 | 2012-09-01 01:05:17 +0800 | [diff] [blame] | 88 | # oldnoconfig is an alias of olddefconfig, because people already are dependent |
Diego Viola | 39c3f1b | 2015-05-31 14:35:51 -0300 | [diff] [blame] | 89 | # on its behavior (sets new symbols to their default value but not 'n') with the |
Adam Lee | fb16d89 | 2012-09-01 01:05:17 +0800 | [diff] [blame] | 90 | # counter-intuitive name. |
Michal Marek | 1cba0c3 | 2015-04-08 11:11:57 +0200 | [diff] [blame] | 91 | oldnoconfig: olddefconfig |
Adam Lee | fb16d89 | 2012-09-01 01:05:17 +0800 | [diff] [blame] | 92 | |
Sam Ravnborg | 7cf3d73 | 2010-07-31 23:35:34 +0200 | [diff] [blame] | 93 | savedefconfig: $(obj)/conf |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 94 | $< $(silent) --$@=defconfig $(Kconfig) |
Sam Ravnborg | 7cf3d73 | 2010-07-31 23:35:34 +0200 | [diff] [blame] | 95 | |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 96 | defconfig: $(obj)/conf |
| 97 | ifeq ($(KBUILD_DEFCONFIG),) |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 98 | $< $(silent) --defconfig $(Kconfig) |
Michael Ellerman | bd960f0 | 2015-10-15 14:33:57 +1100 | [diff] [blame] | 99 | else ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),) |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 100 | @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'" |
| 101 | $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig) |
Michael Ellerman | d2036f3 | 2015-09-23 15:40:34 +1000 | [diff] [blame] | 102 | else |
| 103 | @$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'" |
| 104 | $(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 105 | endif |
| 106 | |
| 107 | %_defconfig: $(obj)/conf |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 108 | $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 109 | |
Masahiro Yamada | 63a9103 | 2015-03-13 15:21:43 +0900 | [diff] [blame] | 110 | configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@) |
Josh Triplett | 3aaefce | 2014-08-06 15:21:00 -0700 | [diff] [blame] | 111 | |
Masahiro Yamada | 63a9103 | 2015-03-13 15:21:43 +0900 | [diff] [blame] | 112 | %.config: $(obj)/conf |
| 113 | $(if $(call configfiles),, $(error No configuration exists for this target on this architecture)) |
| 114 | $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles) |
| 115 | +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig |
Josh Triplett | 3aaefce | 2014-08-06 15:21:00 -0700 | [diff] [blame] | 116 | |
| 117 | PHONY += kvmconfig |
Masahiro Yamada | 63a9103 | 2015-03-13 15:21:43 +0900 | [diff] [blame] | 118 | kvmconfig: kvm_guest.config |
| 119 | @: |
Josh Triplett | 3aaefce | 2014-08-06 15:21:00 -0700 | [diff] [blame] | 120 | |
Luis R. Rodriguez | 6c66850 | 2015-05-20 11:53:39 -0700 | [diff] [blame] | 121 | PHONY += xenconfig |
| 122 | xenconfig: xen.config |
| 123 | @: |
| 124 | |
Josh Triplett | 0da1d4a | 2014-08-08 16:25:47 -0700 | [diff] [blame] | 125 | PHONY += tinyconfig |
Masahiro Yamada | 63a9103 | 2015-03-13 15:21:43 +0900 | [diff] [blame] | 126 | tinyconfig: |
| 127 | $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config |
Josh Triplett | 0da1d4a | 2014-08-08 16:25:47 -0700 | [diff] [blame] | 128 | |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 129 | # Help text used by make help |
| 130 | help: |
| 131 | @echo ' config - Update current config utilising a line-oriented program' |
Geert Uytterhoeven | fa75a72 | 2015-05-26 13:39:54 +0200 | [diff] [blame] | 132 | @echo ' nconfig - Update current config utilising a ncurses menu based' |
| 133 | @echo ' program' |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 134 | @echo ' menuconfig - Update current config utilising a menu based program' |
Diego Viola | 092373c | 2015-04-06 06:27:45 -0300 | [diff] [blame] | 135 | @echo ' xconfig - Update current config utilising a Qt based front-end' |
Diego Viola | 39c3f1b | 2015-05-31 14:35:51 -0300 | [diff] [blame] | 136 | @echo ' gconfig - Update current config utilising a GTK+ based front-end' |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 137 | @echo ' oldconfig - Update current config utilising a provided .config as base' |
Steven Rostedt | 03fa25d | 2009-04-29 22:52:22 -0400 | [diff] [blame] | 138 | @echo ' localmodconfig - Update current config disabling modules not loaded' |
Steven Rostedt | 281c9da | 2009-04-29 22:52:23 -0400 | [diff] [blame] | 139 | @echo ' localyesconfig - Update current config converting local mods to core' |
Markus Heidelberg | 590a585 | 2009-05-18 01:36:46 +0200 | [diff] [blame] | 140 | @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps' |
Sam Ravnborg | 0748cb3 | 2010-07-31 23:35:31 +0200 | [diff] [blame] | 141 | @echo ' defconfig - New config with default from ARCH supplied defconfig' |
Sam Ravnborg | 7cf3d73 | 2010-07-31 23:35:34 +0200 | [diff] [blame] | 142 | @echo ' savedefconfig - Save current config as ./defconfig (minimal config)' |
Jesper Juhl | e11f049 | 2006-02-25 21:52:50 +0100 | [diff] [blame] | 143 | @echo ' allnoconfig - New config where all options are answered with no' |
Sam Ravnborg | 0748cb3 | 2010-07-31 23:35:31 +0200 | [diff] [blame] | 144 | @echo ' allyesconfig - New config where all options are accepted with yes' |
| 145 | @echo ' allmodconfig - New config selecting modules when possible' |
| 146 | @echo ' alldefconfig - New config with all symbols set to default' |
| 147 | @echo ' randconfig - New config with random answer to all options' |
Sam Ravnborg | 861b4ea | 2010-07-31 23:35:28 +0200 | [diff] [blame] | 148 | @echo ' listnewconfig - List new options' |
Geert Uytterhoeven | fa75a72 | 2015-05-26 13:39:54 +0200 | [diff] [blame] | 149 | @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their' |
| 150 | @echo ' default value' |
Luis R. Rodriguez | 9bcd776 | 2015-05-20 11:53:38 -0700 | [diff] [blame] | 151 | @echo ' kvmconfig - Enable additional options for kvm guest kernel support' |
Luis R. Rodriguez | 6c66850 | 2015-05-20 11:53:39 -0700 | [diff] [blame] | 152 | @echo ' xenconfig - Enable additional options for xen dom0 and guest kernel support' |
Josh Triplett | 0da1d4a | 2014-08-08 16:25:47 -0700 | [diff] [blame] | 153 | @echo ' tinyconfig - Configure the tiniest possible kernel' |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 154 | |
Sam Ravnborg | 2982de6 | 2006-07-27 22:10:27 +0200 | [diff] [blame] | 155 | # lxdialog stuff |
| 156 | check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh |
| 157 | |
Rob Landley | e9e40e1 | 2007-10-15 19:23:12 -0500 | [diff] [blame] | 158 | # Use recursively expanded variables so we do not call gcc unless |
Sam Ravnborg | 2982de6 | 2006-07-27 22:10:27 +0200 | [diff] [blame] | 159 | # we really need to do so. (Do not call gcc as part of make mrproper) |
Arnaud Lacombe | 9ba9568 | 2010-08-22 20:03:06 -0400 | [diff] [blame] | 160 | HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \ |
| 161 | -DLOCALE |
Sam Ravnborg | 2982de6 | 2006-07-27 22:10:27 +0200 | [diff] [blame] | 162 | |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 163 | # =========================================================================== |
| 164 | # Shared Makefile for the various kconfig executables: |
| 165 | # conf: Used for defconfig, oldconfig and related targets |
nir.tzachar@gmail.com | 692d97c | 2009-11-25 12:28:43 +0200 | [diff] [blame] | 166 | # nconf: Used for the nconfig target. |
| 167 | # Utilizes ncurses |
Markus Heidelberg | 6f26e5e | 2009-05-18 01:36:45 +0200 | [diff] [blame] | 168 | # mconf: Used for the menuconfig target |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 169 | # Utilizes the lxdialog package |
| 170 | # qconf: Used for the xconfig target |
Diego Viola | 092373c | 2015-04-06 06:27:45 -0300 | [diff] [blame] | 171 | # Based on Qt which needs to be installed to compile it |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 172 | # gconf: Used for the gconfig target |
Diego Viola | 39c3f1b | 2015-05-31 14:35:51 -0300 | [diff] [blame] | 173 | # Based on GTK+ which needs to be installed to compile it |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 174 | # object files used by all kconfig flavours |
| 175 | |
Sam Ravnborg | 2982de6 | 2006-07-27 22:10:27 +0200 | [diff] [blame] | 176 | lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o |
| 177 | lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o |
| 178 | |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 179 | conf-objs := conf.o zconf.tab.o |
nir.tzachar@gmail.com | 692d97c | 2009-11-25 12:28:43 +0200 | [diff] [blame] | 180 | mconf-objs := mconf.o zconf.tab.o $(lxdialog) |
| 181 | nconf-objs := nconf.o zconf.tab.o nconf.gui.o |
Arnaldo Carvalho de Melo | 3b9fa09 | 2005-05-05 15:09:46 -0700 | [diff] [blame] | 182 | kxgettext-objs := kxgettext.o zconf.tab.o |
Peter Foley | f194304 | 2011-04-26 18:00:05 -0400 | [diff] [blame] | 183 | qconf-cxxobjs := qconf.o |
Arnaud Lacombe | 5a6f8d2 | 2011-06-01 16:14:47 -0400 | [diff] [blame] | 184 | qconf-objs := zconf.tab.o |
| 185 | gconf-objs := gconf.o zconf.tab.o |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 186 | |
Masahiro Yamada | 022af62 | 2014-08-19 16:34:22 +0900 | [diff] [blame] | 187 | hostprogs-y := conf nconf mconf kxgettext qconf gconf |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 188 | |
Arnaud Lacombe | 5a6f8d2 | 2011-06-01 16:14:47 -0400 | [diff] [blame] | 189 | clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck |
Arnaud Lacombe | 2f76b35 | 2011-05-23 01:08:19 -0400 | [diff] [blame] | 190 | clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h |
EGRY Gabor | 1020026 | 2008-01-11 23:40:00 +0100 | [diff] [blame] | 191 | clean-files += config.pot linux.pot |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 192 | |
Sam Ravnborg | 6e588f6 | 2007-12-09 20:11:15 +0100 | [diff] [blame] | 193 | # Check that we have the required ncurses stuff installed for lxdialog (menuconfig) |
| 194 | PHONY += $(obj)/dochecklxdialog |
| 195 | $(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog |
| 196 | $(obj)/dochecklxdialog: |
Arnaud Lacombe | 7080e47 | 2010-08-16 00:19:04 -0400 | [diff] [blame] | 197 | $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf) |
Sam Ravnborg | 6e588f6 | 2007-12-09 20:11:15 +0100 | [diff] [blame] | 198 | |
| 199 | always := dochecklxdialog |
| 200 | |
Sam Ravnborg | aa1e5ef | 2007-08-12 23:15:44 +0200 | [diff] [blame] | 201 | # Add environment specific flags |
| 202 | HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS)) |
Yuri Vasilevski | 70a6a0c | 2005-10-30 15:03:20 -0800 | [diff] [blame] | 203 | |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 204 | # generated files seem to need this to find local include files |
Arnaud Lacombe | 2f76b35 | 2011-05-23 01:08:19 -0400 | [diff] [blame] | 205 | HOSTCFLAGS_zconf.lex.o := -I$(src) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 206 | HOSTCFLAGS_zconf.tab.o := -I$(src) |
| 207 | |
Arnaud Lacombe | 378dbb2 | 2011-05-23 02:08:52 -0400 | [diff] [blame] | 208 | LEX_PREFIX_zconf := zconf |
| 209 | YACC_PREFIX_zconf := zconf |
| 210 | |
Arnaud Lacombe | 5a6f8d2 | 2011-06-01 16:14:47 -0400 | [diff] [blame] | 211 | HOSTLOADLIBES_qconf = $(KC_QT_LIBS) |
| 212 | HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 213 | |
Arnaud Lacombe | 5a6f8d2 | 2011-06-01 16:14:47 -0400 | [diff] [blame] | 214 | HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0` |
Adrian Bunk | 3719314 | 2006-01-02 11:25:30 +0100 | [diff] [blame] | 215 | HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \ |
Arnaud Lacombe | 1ea3ad4 | 2011-06-05 23:36:05 -0400 | [diff] [blame] | 216 | -Wno-missing-prototypes |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 217 | |
Arnaud Lacombe | 7080e47 | 2010-08-16 00:19:04 -0400 | [diff] [blame] | 218 | HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC)) |
| 219 | |
Justin Lecher | 544e7e5 | 2013-03-06 14:02:02 +0100 | [diff] [blame] | 220 | HOSTLOADLIBES_nconf = $(shell \ |
Brian Norris | 7285996 | 2014-06-04 00:52:31 -0700 | [diff] [blame] | 221 | pkg-config --libs menuw panelw ncursesw 2>/dev/null \ |
| 222 | || pkg-config --libs menu panel ncurses 2>/dev/null \ |
Justin Lecher | 544e7e5 | 2013-03-06 14:02:02 +0100 | [diff] [blame] | 223 | || echo "-lmenu -lpanel -lncurses" ) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 224 | $(obj)/qconf.o: $(obj)/.tmp_qtcheck |
| 225 | |
Masahiro Yamada | 022af62 | 2014-08-19 16:34:22 +0900 | [diff] [blame] | 226 | ifeq ($(MAKECMDGOALS),xconfig) |
Roman Zippel | b3a5225 | 2005-11-21 21:32:38 -0800 | [diff] [blame] | 227 | $(obj)/.tmp_qtcheck: $(src)/Makefile |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 228 | -include $(obj)/.tmp_qtcheck |
| 229 | |
Diego Viola | 092373c | 2015-04-06 06:27:45 -0300 | [diff] [blame] | 230 | # Qt needs some extra effort... |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 231 | $(obj)/.tmp_qtcheck: |
Thiago Macieira | d1b0dc9 | 2015-09-22 11:36:39 -0700 | [diff] [blame] | 232 | @set -e; $(kecho) " CHECK qt"; \ |
Thiago Macieira | 588446a | 2015-11-01 21:12:53 -0600 | [diff] [blame] | 233 | if pkg-config --exists Qt5Core; then \ |
| 234 | cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \ |
| 235 | libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \ |
| 236 | moc=`pkg-config --variable=host_bins Qt5Core`/moc; \ |
| 237 | elif pkg-config --exists QtCore; then \ |
| 238 | cflags=`pkg-config --cflags QtCore QtGui`; \ |
| 239 | libs=`pkg-config --libs QtCore QtGui`; \ |
| 240 | moc=`pkg-config --variable=moc_location QtCore`; \ |
Sam Ravnborg | ab919c0 | 2005-11-06 11:05:21 +0100 | [diff] [blame] | 241 | else \ |
Thiago Macieira | d1b0dc9 | 2015-09-22 11:36:39 -0700 | [diff] [blame] | 242 | echo >&2 "*"; \ |
Thiago Macieira | 588446a | 2015-11-01 21:12:53 -0600 | [diff] [blame] | 243 | echo >&2 "* Could not find Qt via pkg-config."; \ |
| 244 | echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \ |
Thiago Macieira | d1b0dc9 | 2015-09-22 11:36:39 -0700 | [diff] [blame] | 245 | echo >&2 "*"; \ |
| 246 | exit 1; \ |
Roman Zippel | b3a5225 | 2005-11-21 21:32:38 -0800 | [diff] [blame] | 247 | fi; \ |
| 248 | echo "KC_QT_CFLAGS=$$cflags" > $@; \ |
| 249 | echo "KC_QT_LIBS=$$libs" >> $@; \ |
| 250 | echo "KC_QT_MOC=$$moc" >> $@ |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 251 | endif |
| 252 | |
| 253 | $(obj)/gconf.o: $(obj)/.tmp_gtkcheck |
| 254 | |
Masahiro Yamada | 022af62 | 2014-08-19 16:34:22 +0900 | [diff] [blame] | 255 | ifeq ($(MAKECMDGOALS),gconfig) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 256 | -include $(obj)/.tmp_gtkcheck |
| 257 | |
Diego Viola | 39c3f1b | 2015-05-31 14:35:51 -0300 | [diff] [blame] | 258 | # GTK+ needs some extra effort, too... |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 259 | $(obj)/.tmp_gtkcheck: |
Adrian Bunk | 3719314 | 2006-01-02 11:25:30 +0100 | [diff] [blame] | 260 | @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \ |
| 261 | if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \ |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 262 | touch $@; \ |
| 263 | else \ |
Michal Marek | 5b580fa | 2012-07-07 23:32:18 +0200 | [diff] [blame] | 264 | echo >&2 "*"; \ |
| 265 | echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \ |
| 266 | echo >&2 "*"; \ |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 267 | false; \ |
| 268 | fi \ |
| 269 | else \ |
Michal Marek | 5b580fa | 2012-07-07 23:32:18 +0200 | [diff] [blame] | 270 | echo >&2 "*"; \ |
| 271 | echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \ |
| 272 | echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \ |
| 273 | echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \ |
| 274 | echo >&2 "*"; \ |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 275 | false; \ |
| 276 | fi |
| 277 | endif |
| 278 | |
Arnaud Lacombe | 2f76b35 | 2011-05-23 01:08:19 -0400 | [diff] [blame] | 279 | $(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 280 | |
Arnaud Lacombe | 5a6f8d2 | 2011-06-01 16:14:47 -0400 | [diff] [blame] | 281 | $(obj)/qconf.o: $(obj)/qconf.moc |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 282 | |
Yaakov Selkowitz | ebca026 | 2012-07-04 18:31:11 -0500 | [diff] [blame] | 283 | quiet_cmd_moc = MOC $@ |
| 284 | cmd_moc = $(KC_QT_MOC) -i $< -o $@ |
| 285 | |
| 286 | $(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck |
| 287 | $(call cmd,moc) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 288 | |
Diego Viola | 39c3f1b | 2015-05-31 14:35:51 -0300 | [diff] [blame] | 289 | # Extract gconf menu items for i18n support |
EGRY Gabor | 46d2631 | 2008-01-11 23:46:11 +0100 | [diff] [blame] | 290 | $(obj)/gconf.glade.h: $(obj)/gconf.glade |
Peter Foley | 2d80eb0 | 2011-04-26 18:16:53 -0400 | [diff] [blame] | 291 | $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \ |
Peter Foley | a24a1b8 | 2011-04-26 18:13:05 -0400 | [diff] [blame] | 292 | $(obj)/gconf.glade |